<?php
class widgetActivityListcomments extends cmsWidget {

    public function run(){

        // Получаем опции виджета
		$show_avatars     = $this->getOption('show_avatars');
        $show_date_groups = $this->getOption('date_group');
        $limit            = $this->getOption('limitcomments', 10);
        $dataset          = $this->getOption('dataset', 'all');
		$comment_add      = $this->getOption('comment_add') ? $this->getOption('comment_add') : '&rarr;';

        // Получаем контроллер виджета
		$activity = cmsCore::getController('activity');

        // Применяем сортировку по дате
		$activity->model->orderBy('date_pub', 'desc');

        // Применяем фильтры датасетов
		if ($dataset != 'all') {

            $datasets = $activity->getDatasets();
            $dataset = $datasets[$dataset];

            if (isset($dataset['filter']) && is_callable($dataset['filter'])){
                $dataset['filter']($activity->model);
            }

        }

        // Применяем фильтры приватности
		$activity->model->filterPrivacy()->enableHiddenParentsFilter()->filterEqual('is_pub', 1);

        // Получаем записи активности с нужным лимитом
		$activ = $activity->model->limit($limit)->getEntries();
		
		// Получаем комментарии с нужным лимитом
		$comments = $activity->model_comments->filterIsNull('is_deleted')->limit($limit)->getComments();
		
		// Заменяем колонки комментариев на колонки активности
		foreach($comments as $comment){
				$comment['description'] = !empty($comment['description']) ? 
				$comment['description'] : 
				$comment_add . ' <a class="subject" href="'. $comment['target_url'] .'#comment_'.$comment['id'].'">'. html_strip($comment['target_title'], 50).'</a>
				<br/>'.html_clean($comment['content_html'], 50);
				$comment['user']['nickname'] = !empty($comment['user']['nickname']) ? $comment['user']['nickname'] :  $comment['author_name'];              
				$comment['date_diff'] = !empty($comment['date_diff']) ? $comment['date_diff'] : $comment['date_pub'];	
				
				$comments_mix[] = $comment;
		}
		
		// Сливаем массивы активности и комментариев в один массив
		$items = array_merge($activ, $comments_mix);
		
		// Если нечего отображать - выходим
		if (!$items) { return false; }
		
		// Сортируем результирующий массив по дате
		uasort($items, function($a, $b){
				return (strtotime($b['date_pub']) > strtotime($a['date_pub']));
		});
		
        // Обрезаем по лимиту
		$items = array_slice($items, 0, $limit);

        // Отправляем в шаблон
		return array(
            'show_avatars'     => $show_avatars,
            'show_date_groups' => $show_date_groups,
            'items'            => cmsEventsManager::hook('activity_before_list', $items)
        );

    }

}
